precision mediump float;//给出默认的浮点精度
varying vec2 vTextureCoord;//从顶点着色器传递过来的纹理坐标
uniform sampler2D sTexture;//纹理内容数据

uniform mat3 uDataMatrix1; //矩阵1
uniform mat4 uDataMatrix2; //矩阵2
uniform int mohu;//矩阵维数。

const float M_PI = 3.141592;
const float e = 2.71828;

float getKernelValue(float columnIndex,float rowIndex) {
//   float sigma = 1.5;
   float sigma = distance(vec2(0.0,0.0),vec2(columnIndex,rowIndex)) / 3.0;
       float sigma2 = 2.0 * sigma * sigma;
       float sigmap = sigma2 * M_PI;
sigmap = 3.0;

  float paraLeft = 1.0 / 2.0 * M_PI * pow(sigmap, 2.0);
  float powerValue = -1.0*(pow(columnIndex,2.0)+pow(rowIndex,2.0)) /(2.0 * pow(sigmap, 2.0));
  float paraRight = pow(e,powerValue);
  return  paraLeft*paraRight;
}
vec4 getTargetColorValue(float columnIndex,float rowIndex) {
     vec2 offset0=vec2(columnIndex/720.0,rowIndex/1280.0);
     return texture2D(sTexture, vTextureCoord.st + offset0);
}

void main() {           
    //给出卷积内核中各个元素对应像素相对于待处理像素的纹理坐标偏移量
    vec4 sum;//最终的颜色和

    int xMin = -1*mohu/2;
    int xMax = 1*mohu/2;

    int yMin = -1*mohu/2;
    int yMax = 1*mohu/2;

    float totalWeight;
    for (int y = yMin;y<=yMax;y++) {
       for (int x = xMin;x<=xMax;x++) {
          totalWeight +=getKernelValue(float(x),float(y));
       }
     }

     for (int y = yMin;y<=yMax;y++) {
       for (int x = xMin;x<=xMax;x++) {
         float nearByPointX = vTextureCoord.s + float(x)/720.0;
         float nearByPointY = vTextureCoord.t + float(y)/1280.0;
         if (nearByPointX>=0.0 && nearByPointX<=1.0 && nearByPointY>=0.0 && nearByPointY<=1.0 ) {
              sum +=getKernelValue(float(x),float(y))*getTargetColorValue(float(x),float(y));
          }
       }
     }
     gl_FragColor = sum/totalWeight;
}         
